/* built-in2.p
   Demonstrates handling of built-in system errors
   Author: Peter van Dam, Future Proof Software */
   
DEFINE VARIABLE hBuffer# AS HANDLE NO-UNDO. 

CREATE BUFFER hBuffer# FOR TABLE "customer". 
  
DO TRANSACTION ON ERROR UNDO, THROW:

  hBuffer#:FIND-UNIQUE("WHERE CustNum EQ 1", EXCLUSIVE-LOCK). 
  
  MESSAGE hBuffer#::comments VIEW-AS ALERT-BOX. 

  hBuffer#::comments = STRING(NOW). 

  hBuffer#:BUFFER-RELEASE().
  
  hBuffer#:FIND-UNIQUE("WHERE CustNum EQ 1000", NO-LOCK).   

  MESSAGE "Transaction succeeded." 
          VIEW-AS ALERT-BOX INFORMATION. 
                    
END. /* TRANSACTION */ 

MESSAGE "ERROR-STATUS:" ERROR-STATUS:ERROR SKIP 
  "NUM-MESSAGES:" ERROR-STATUS:NUM-MESSAGES 
  VIEW-AS ALERT-BOX INFORMATION. 

CATCH e AS Progress.Lang.Error :
  RUN errorstack.w (INPUT e). 
  DELETE OBJECT e.   	
END CATCH.

FINALLY: 
  DELETE OBJECT hBuffer#.
END FINALLY. 


