/* getcustomers.p 
   Return a batch of customer records 
   Author: Peter van Dam, Future Proof Software */

DEFINE INPUT PARAMETER batchSize AS INT NO-UNDO.
DEFINE INPUT PARAMETER batchNumber AS INT NO-UNDO.
DEFINE OUTPUT PARAMETER TABLE-HANDLE hTable.
DEFINE OUTPUT PARAMETER lMore AS LOGICAL NO-UNDO.
DEFINE OUTPUT PARAMETER cError AS CHARACTER NO-UNDO.

RUN getrecords.p (INPUT "customer",
                  INPUT "custNums = 1",
                  INPUT "*",
                  INPUT batchSize,
                  INPUT batchNumber,
                  OUTPUT lMore,
                  OUTPUT TABLE-HANDLE hTable).                 
 
CATCH errorObject AS Progress.Lang.SysError:  	
  DEFINE VARIABLE iMessage# AS INT NO-UNDO.
  DO iMessage# = 1 TO errorObject:numMessages:
    ASSIGN cError = TRIM(SUBSTITUTE("&1~n&2",
                                    cError, 
                                    errorObject:getMessage(iMessage#)),
                         "~n").
  END.  
  DELETE OBJECT errorObject.
END CATCH.

FINALLY: 
  DELETE OBJECT hTable NO-ERROR.
END FINALLY.
